#include "dcastaway.h"
#include "config.h"
#include "68000.h"
#include "st.h"
#include "mem.h"
#include "op68k.h"
		

extern unsigned long (*jmp_table[8192])(operin);
extern unsigned char fdc_motor;
extern unsigned int fdc_commands_executed;
extern int mainMenu_frameskip;
extern int mainMenu_sound;
int readdsk=1;
int emulating=0;
int frameskip=0;
int maxframeskip=-1;

#define AUTOFRAME (1000 / 50)
#define AUTOFRAME_MIN (AUTOFRAME / 10)
Uint32 autoframeskip_next=0;


#define cpuinst\
	address = pc&MEMADDRMASK;\
	if (address<MEMSIZE) myinst=biginst=ReadSL(mymembase+address);\
	else myinst=biginst=ReadSL(myrombase+address);\
	pc+=2;\
	cycleco+=(*jmp_table[(myinst<<16)>>19])(reg);\


static __inline__ unsigned long cpuloop10(unsigned long *reg) {
	register unsigned long cycleco=0;
	register unsigned long address,timeinst;
	register int8 *mymembase=membase;
	register int8 *myrombase=rombase;
	register uint32 myinst;
	//Execute 10 instructions
	cpuinst
		cpuinst
		cpuinst
		cpuinst
		cpuinst
		cpuinst
		cpuinst
		cpuinst
		cpuinst
		cpuinst
		return cycleco;
}

#ifdef DREAMCAST
extern int __sdl_dc_wait_vblank;
#endif

static __inline__ int autoframeskip(void)
{
#ifdef DREAMCAST
	if (__sdl_dc_wait_vblank)
		return 0;
#endif
	Uint32 now=SDL_GetTicks();
	int ret=0;
	if (now>autoframeskip_next-AUTOFRAME_MIN)
	{
		if (now<autoframeskip_next+AUTOFRAME)
			ret=1;
		else
		if (now<autoframeskip_next+(AUTOFRAME*2))
			ret=2;
		else
		if (now<autoframeskip_next+(AUTOFRAME*3))
			ret=3;
		else
		if (now<autoframeskip_next+(AUTOFRAME*4))
			ret=4;
		else
			ret=5;
	}
	else
	{
		Uint32 diff=autoframeskip_next-now;
		if (diff>AUTOFRAME_MIN)
		SDL_Delay(diff);
	}
	autoframeskip_next+=AUTOFRAME;
	return ret;
}

static void emulate(void)
{
    int hsync=0, hbl=0;
    unsigned long cycleco=0;
    unsigned long oldpend,newpend;
    int vsyncpend=0, hsyncpend=0;
    int delay_fdc_motor=0;

    autoframeskip_next=SDL_GetTicks()+AUTOFRAME;
    emulating=1;
    while(emulating)
    {
	cycleco=cpuloop10(reg);

	//MFP timer A delay mode
	if (mfp_ascale>1) {
		mfp_acount-=mfp_ascale*cycleco;
		if (mfp_acount<=0) {
		  do {mfp_acount+=mfp_tadr;} while (mfp_acount<=0);
		  oldpend=mfp_ipra; newpend=(oldpend|0x20)&mfp_iera;
		  if (newpend!=oldpend) {mfp_ipra=newpend; recalc_int=1;}
		}
	}
	//MFP timer B delay mode
	if (mfp_bscale>1) {
		mfp_bcount-=mfp_bscale*cycleco;
		if (mfp_bcount<=0) {
		  do {mfp_bcount+=mfp_tbdr;} while (mfp_bcount<=0);
			oldpend=mfp_ipra; newpend=(oldpend|0x1)&mfp_iera;
			if (newpend!=oldpend) {mfp_ipra=newpend; recalc_int=1;}
		}
	}
	//MFP timer C delay mode
	if (mfp_cscale>1) {
		mfp_ccount-=mfp_cscale*cycleco;
		if (mfp_ccount<=0) {
		  do {mfp_ccount+=mfp_tcdr;} while (mfp_ccount<=0);
			oldpend=mfp_iprb; newpend=(oldpend|0x20)&mfp_ierb;
			if (newpend!=oldpend) {mfp_iprb=newpend; recalc_int=1;}
		}
	}
	//MFP timer D delay mode
	if (mfp_dscale>1) {
		mfp_dcount-=mfp_dscale*cycleco;
		if (mfp_dcount<=0) {
		  do {mfp_dcount+=mfp_tddr;} while (mfp_dcount<=0);
			oldpend=mfp_iprb; newpend=(oldpend|0x10)&mfp_ierb;
			if (newpend!=oldpend) {mfp_iprb=newpend; recalc_int=1;}
		}
	}
	vid_adr+=(cycleco)&(~3);
	hsync-=cycleco;
	if (hsync<=0) {
#ifdef DREAMCAST
		if (__sdl_dc_wait_vblank && !hbl)
			vid_waitvbl();
#endif
		hbl++; hsync+=512;
		//Generate hbl interrupt
		if (hsyncpend==0) {hsyncpend=1; recalc_int=1;}
		
		//Trigger event counters for visible scan-lines
		if (hbl<64) {
			vid_adr=(vid_baseh<<16)+(vid_basem<<8);
		}
		else if (hbl<264) {
			//Do IO every 64 hbls
			if (!(hbl&63)) {
				//Handle event outside the emulation
			  do_events();
			  //if (exit_castaway) {exit_castaway=0; exitsound(); return;}
				//Generate FDC interrupt in mfp?
				if (!(mfp_gpip & 0x20)) {
					mfp_iprb |= 0x80;
					mfp_iprb &= mfp_ierb;
					recalc_int=1;
				} 
				//Generate ACIA interrupt in mfp?
				IkbdWriteBuffer();
				if (!(mfp_gpip & 0x10)) {
					mfp_iprb |= 0x40;
					mfp_iprb &= mfp_ierb;
					recalc_int=1;
				}
			}
			//Update video address
			vid_adr=(vid_baseh<<16)+(vid_basem<<8)+(hbl-63)*160;
			if (!frameskip){
			  //Draw screen line
			  if (vid_shiftmode==COL2) {
			      Redraw_med ( hbl - 64, vid_adr - 160 );
			  } else {
			      Redraw ( hbl - 64, vid_adr - 160 );
			  }
			}

			// if on last scanline, render status
			if ( hbl - 64 == 199 ) {
			  render_status();
			}

			//Timer-A event count mode
			if (mfp_ascale==1) {
				mfp_acount-=1048576;
				if (mfp_acount<=0) {
					mfp_acount=mfp_tadr;
					oldpend=mfp_ipra; newpend=(oldpend|0x20)&mfp_iera;
					if (newpend!=oldpend) {mfp_ipra=newpend; recalc_int=1;}
				}
			}
			//Timer-B event count mode
			if (mfp_bscale==1) {
				mfp_bcount-=1048576;
				if (mfp_bcount<=0) {
					mfp_bcount=mfp_tbdr;
					oldpend=mfp_ipra; newpend=(oldpend|0x1)&mfp_iera;
					if (newpend!=oldpend) {mfp_ipra=newpend; recalc_int=1;}
				}
			}
		}
		//Vertical blank?
		else if (hbl>=313){
			Draw_border();
			frameskip--;
			Sound_Update_VBL();
    			if (fdc_commands_executed)
    			{
				if (fdc_commands_executed>1)
	    				drawDisk();
				else
					drawDiskEmpty();
	    			fdc_commands_executed--;
    			}
			if (maxframeskip<0)
				frameskip=autoframeskip();
			else
				if (frameskip<0)
					frameskip=maxframeskip;
			hbl=0;
			//Generate vsync interrupt
			vsyncpend=1; recalc_int=1;
			//Do fdc spinup
			if (fdc_motor){
				if (delay_fdc_motor>150) {
					fdc_status &= ~0x80;
					delay_fdc_motor=0;
					fdc_motor=0;
				}
				else delay_fdc_motor++;
			}
		}
	}
	//Recalculate interrupts?
	if (recalc_int==1) {
		int mfp_int;
		mfp_int=0;
		if (6>GetI()) {
			//Mfp interrupt
			{
				int n, number;
				uint16 imr, ipr, isr, irr;
				int in_request;
				//Find in_request and in_service
				imr = (mfp_imra<<8)+mfp_imrb;
				ipr = (mfp_ipra<<8)+mfp_iprb;
				irr = imr & ipr;
				isr = (mfp_isra<<8) + mfp_isrb;
				//in_request higher than in_service?
				if (irr>isr) {
					//Find highest set bit
					for (in_request = 15; in_request > 0; in_request--) {
						if (irr & 0x8000) break;
						irr <<= 1;
					}
					isr = 1 << in_request;
					//Set interrupt in service bits in MFP
					if (mfp_ivr & 0x8) {
						mfp_isra |= isr >> 8;
						mfp_isrb |= isr;
					}else{
						mfp_isra &= (~isr) >> 8;
						mfp_isrb &= ~isr;
					}
					//Clear interrupt pending bits in MFP
					mfp_ipra &= ~(isr >> 8);
					mfp_iprb &= ~isr;
					//Pass interrupt to cpu
					number = in_request | (mfp_ivr & 0xf0);
					Interrupt(number, 6);
					mfp_int=1;
				}
			}
		}
		if (!mfp_int){
			if (vsyncpend==1 && 4>GetI()) {
				Interrupt(AUTOINT4, 4);
				vsyncpend=0;
			}else	if (hsyncpend==1 && 2>GetI()) {
				Interrupt(AUTOINT2, 2);
				hsyncpend=0;
			}
			
		}
		if (!vsyncpend&&!hsyncpend) recalc_int=0;
	}
    }
}

void dcastaway(void)
{
    Init();
    render_init();
    events_init();
    vkbd_init();
    if (mainMenu_sound)
   	audio_init();
    maxframeskip=mainMenu_frameskip;

    render_blank_screen();
    emulate();

    if (mainMenu_sound)
    	audio_stop();
    vkbd_quit();
}
