#include "dcastaway.h"

#include "menu.h"

#include "vkbd.h"
#include "keymap.h"

static SDL_Joystick *jstick[2]={NULL,NULL};
extern int mainMenu_frameskip;
extern int mainMenu_sound;
extern int maxframeskip;

extern void render_up_screen(void);
extern void render_down_screen(void);

#ifdef DREAMCAST
extern int  __sdl_dc_emulate_keyboard;
extern int  __sdl_dc_emulate_mouse;
#endif


extern int fdc_commands_executed;
extern Uint32 autoframeskip_next;

int changed_fdc0;


#define JOY_UP       1
#define JOY_DOWN     2
#define JOY_LEFT     4
#define JOY_RIGHT    8
#define JOY_BUTTON 128

void goMenu(void){
	int exitmode;

	changed_fdc0=0;
    	audio_stop();
	vkbd_quit();
	init_text(0);
	exitmode=run_mainMenu();
	quit_text();
	maxframeskip=mainMenu_frameskip;
#ifdef DREAMCAST
        __sdl_dc_emulate_keyboard=0;
#endif
	if (changed_fdc0)
		FDCInit(0);
	render_blank_screen();
	fdc_commands_executed=0;
	if (exitmode==2)
	{
//		emulating=0;
		MemClean();
		IOInit();
  		Ikbd_Reset();
    		HWReset();
	}
        vkbd_init();
	render_down_screen();
	if (mainMenu_sound)
	{
		Sound_Update_VBL();
    		audio_init();
	}
	autoframeskip_next=SDL_GetTicks()+10;
}

void events_init(void)
{
     int it=100;
#ifdef DREAMCAST
    __sdl_dc_emulate_keyboard=0;
#endif
    SDL_JoystickEventState(SDL_ENABLE);
    if (jstick[0]==NULL)
 	   jstick[0]=SDL_JoystickOpen(0);
    if (jstick[1]==NULL)
 	   jstick[1]=SDL_JoystickOpen(1);
    while(it-->0)
    {
	    SDL_Event event;
	    if( SDL_PollEvent(&event) )
		    SDL_Delay(5);
	    SDL_Delay(10);
    }
}

void do_events (void) 
{
    static int display_vkbd;
    static int joystateold[2]={0,0};
    int hat,jsn=0,joystate[2];
    SDL_Event event;
    SDLKey sym;
    static Uint32 ticks=-1;
    Uint32 now=SDL_GetTicks();

    joystate[0]=joystateold[0];
    joystate[1]=joystateold[1];
    if ((now-ticks>100)&&(vkbd_mode))
    {
	    vkbd_key=vkbd_process();
	    ticks=now;
    }

    /* Just process events, if there */
    if( SDL_PollEvent(&event) ) {

        switch(event.type) {
	case SDL_JOYBUTTONDOWN:
		jsn=event.jbutton.which;
		switch(event.jbutton.button)
		{
			case 2:
				if (!vkbd_mode)
					joystate[jsn] |= JOY_BUTTON;
				break;
			case 6:
				if (!vkbd_mode)
				{
					if (vkbd_button2)
            					IkbdKeyPress(keysymToAtari[vkbd_button2]);
					else
						joystate[jsn] |= JOY_UP;
				}
				break;
		}
		break;
	case SDL_JOYBUTTONUP:
		jsn=event.jbutton.which;
		switch(event.jbutton.button)
		{
			case 2:
				if (vkbd_mode)
					vkbd_move=VKBD_BUTTON;
				else
					joystate[jsn] &= ~JOY_BUTTON;
				break;
			case 6:
				if (vkbd_mode)
					vkbd_move=VKBD_BUTTON2;
				else
					if (vkbd_button2)
            					IkbdKeyRelease(keysymToAtari[vkbd_button2]|0x80);
					else
						joystate[jsn] &= ~JOY_UP;
				break;
			case 3:
				goMenu();
				break;
		}
		break;
	case SDL_JOYAXISMOTION:
		switch(event.jaxis.axis)
		{
			case 3:
				render_up_screen();
				vkbd_mode=1;
				vkbd_redraw();
				break;
			case 2:
				render_down_screen();
				vkbd_mode=0;
				break;
#ifndef DREAMCAST
			case 1:
				if (event.jaxis.value < -3200)
				{
					joystate[0] |= JOY_UP;
					joystate[0] &= ~JOY_DOWN;
				}
				else
				if (event.jaxis.value > 3200)
				{
					joystate[0] |= JOY_DOWN;
					joystate[0] &= ~JOY_UP;
				}
				else
				{
					joystate[0] &= ~JOY_UP;
					joystate[0] &= ~JOY_DOWN;
				}
				break;
			case 0:
				if (event.jaxis.value < -3200)
				{
					joystate[0] |= JOY_LEFT;
					joystate[0] &= ~JOY_RIGHT;
				}
				else
				if (event.jaxis.value > 3200)
				{
					joystate[0] |= JOY_RIGHT;
					joystate[0] &= ~JOY_LEFT;
				}
				else
				{
					joystate[0] &= ~JOY_LEFT;
					joystate[0] &= ~JOY_RIGHT;
				}
				break;
#endif
		}
		break;
	case SDL_JOYHATMOTION:
		jsn=event.jhat.which;
#ifdef DREAMCAST
                hat=15^(SDL_JoystickGetHat(jstick[jsn],event.jhat.hat));
#else
             	hat=SDL_JoystickGetHat(jstick[jsn],event.jhat.hat);
#endif
		if (vkbd_mode)
		{
			if (hat & SDL_HAT_LEFT)
				vkbd_move |= VKBD_LEFT;
			else
			{
				vkbd_move &= ~VKBD_LEFT;
				if (hat & SDL_HAT_RIGHT)
					vkbd_move |= VKBD_RIGHT;
				else
					vkbd_move &= ~VKBD_RIGHT;
			}
			if (hat & SDL_HAT_UP)
				vkbd_move |= VKBD_UP;
			else
				vkbd_move &= ~VKBD_UP;
				if (hat & SDL_HAT_DOWN)
					vkbd_move |= VKBD_DOWN;
				else
					vkbd_move &= ~VKBD_DOWN;
		}
		else
		{
			if (hat & SDL_HAT_LEFT)
				joystate[jsn] |= JOY_LEFT;
			else 
			{
				joystate[jsn] &= ~JOY_LEFT;
				if (hat & SDL_HAT_RIGHT)
					joystate[jsn] |= JOY_RIGHT;
				else
					joystate[jsn] &= ~JOY_RIGHT;
			}
			if (hat & SDL_HAT_UP)
				joystate[jsn] |= JOY_UP;
			else
			{
				joystate[jsn] &= ~JOY_UP;
				if (hat & SDL_HAT_DOWN)
					joystate[jsn] |= JOY_DOWN;
				else
					joystate[jsn] &= ~JOY_DOWN;
			}
		}
		break;
        case SDL_KEYDOWN:
#ifndef DREAMCAST
	    if (event.key.keysym.sym!=SDLK_F12 && event.key.keysym.sym!=SDLK_F11)
#endif
            IkbdKeyPress(keysymToAtari[event.key.keysym.sym]);
            break;
        case SDL_KEYUP:
#ifndef DREAMCAST
	    if (event.key.keysym.sym==SDLK_F12)
		    goMenu();
	    else
	    if (event.key.keysym.sym==SDLK_F11)
		    video_fullscreen();
	    else
#endif
            IkbdKeyRelease(keysymToAtari[event.key.keysym.sym]|0x80);
            break;
        case SDL_MOUSEMOTION:
//            IkbdMouseMotion(event.motion.xrel, event.motion.yrel);
            IkbdMouseMotion(event.motion.x, event.motion.y);
            break;
        case SDL_MOUSEBUTTONDOWN:
#ifdef DREAMCAST
		if (!__sdl_dc_emulate_mouse)
			IkbdMousePress(2-(event.button.button&1));
		else
			if (!vkbd_mode)
			{
				if (event.button.button==5)
                			IkbdMousePress(2);
				else if (event.button.button==2)
                			IkbdMousePress(1);
			}
#else
		IkbdMousePress(2-(event.button.button&1));
#endif
            break;
        case SDL_MOUSEBUTTONUP:
#ifdef DREAMCAST
		if (!__sdl_dc_emulate_mouse)
			IkbdMouseRelease(2-(event.button.button&1));
		else
			if (!vkbd_mode)
			{
				if (event.button.button==5)
                			IkbdMouseRelease(2);
				else if (event.button.button==2)
                			IkbdMouseRelease(1);
			}
#else
		IkbdMouseRelease(2-(event.button.button&1));
#endif
            break;
        case SDL_QUIT:
            exit(0);
        }
    }
    if (joystateold[jsn]!=joystate[jsn])
    {
	    if (!vkbd_mode)
	    	IkbdJoystickChange(jsn,joystate[jsn]);
	    joystateold[jsn]=joystate[jsn];
    }
    if (vkbd_key)
    {
	    if (vkbd_keysave==-1234567)
	    {
	    	vkbd_keysave=keysymToAtari[vkbd_key];
 	        IkbdKeyPress(keysymToAtari[vkbd_key]);
	    }
    }
    else
	    if (vkbd_keysave!=-1234567)
	    {
            		IkbdKeyRelease(vkbd_keysave|0x80);
			vkbd_keysave=-1234567;
	    }
}

