#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include "menu.h"

#include <sys/stat.h>
#include <unistd.h>
#include<dirent.h>

typedef struct{
	char d_name[256];
	char *map;
	char d_type;
}fichero;

extern int changed_fdc0;

#ifdef DREAMCAST
#define chdir(A) fs_chdir(A)
static char actual_dir[512];
#endif

extern char dcastaway_image_file[];

char *text_str_load_separator="----------------------------------";
char *text_str_load_dir="#DIR#";
char *text_str_load_title="Load Image";
fichero *text_dir_files=NULL;
int text_dir_num_files=0, text_dir_num_files_index=0;

char *text_load=NULL;


#define MAX_FILES_PER_DIR 4096
#define SHOW_MAX_FILES 13

static int min_in_dir=0, max_in_dir=SHOW_MAX_FILES;

static inline int getFiles(char *dir)
{
	int i,j;
	DIR *d;
	text_dir_num_files_index=0;
	min_in_dir=0;
	max_in_dir=SHOW_MAX_FILES;
	text_dir_num_files=0;

	if (text_dir_files!=NULL)
		free(text_dir_files);

	text_draw_window(96,64,140,32,"-------");
	write_text(14,9,"Please wait");
	text_flip();

	text_dir_files=(fichero *)calloc(sizeof(fichero),MAX_FILES_PER_DIR);
#ifdef DREAMCAST
	if (!strcmp(dir,".."))
	{
		int ind;
		for(ind=strlen(actual_dir)-1;ind>0;ind--)
			if (actual_dir[ind]=='/')
			{
				actual_dir[ind]=0;
				break;
			}
		d=opendir(actual_dir);	
	}
	else
#endif
	d=opendir(dir);
	if (d==NULL)
		return -1;
	for(i=0;i<MAX_FILES_PER_DIR;i++)
	{
		struct dirent *actual=readdir(d);
		if (actual==NULL)
			break;
		if ((!strcmp(actual->d_name,"."))||(!strcmp(actual->d_name,"rom")))
		{
			i--;
			continue;
		}
		strcpy(text_dir_files[i].d_name,actual->d_name);
		text_dir_files[i].map=(char *)&text_dir_files[i].d_name;
#ifndef DREAMCAST
		{
			struct stat sstat;
			char *tmp=(char *)calloc(1,256);
			strcpy(tmp,dir);
			strcat(tmp,FILE_SEPARATOR);
			strcat(tmp,text_dir_files[i].d_name);
			if (!stat(tmp, &sstat))
		        	if (S_ISDIR(sstat.st_mode))
					text_dir_files[i].d_type=4;
			free(tmp);
		}
#else
		text_dir_files[i].d_type=actual->d_type & 4;
#endif
	}
	closedir(d);
	text_dir_num_files=i;

#ifndef DREAMCAST
	chdir(dir);
#else
	if (strcmp(dir,MENU_DIR_DEFAULT))
	{
		if (strcmp(dir,".."))
		{
			strcat(actual_dir,"/");
			strcat(actual_dir,dir);
		}
	}
	chdir(actual_dir);
	if (strcmp(actual_dir,MENU_DIR_DEFAULT))
	{
		strcpy(text_dir_files[i].d_name,"..");
		text_dir_files[i].map=(char *)&text_dir_files[i].d_name;
		text_dir_files[i].d_type=4;
		if (text_dir_num_files>0)
		{
			char *pptmp=calloc(1,256);
			int tmptype=text_dir_files[0].d_type;
			strcpy(pptmp,text_dir_files[0].d_name);
			text_dir_files[0].d_type=text_dir_files[text_dir_num_files].d_type;
			text_dir_files[text_dir_num_files].d_type=tmptype;
			strcpy(text_dir_files[0].d_name,text_dir_files[text_dir_num_files].d_name);
			strcpy(text_dir_files[text_dir_num_files].d_name,pptmp);
			free(pptmp);
		}
		text_dir_num_files++;
	}
#endif


	for(i=0;i<text_dir_num_files;i++)
	{
		if (text_dir_files[i].d_type==0)
			for(j=i;j<text_dir_num_files;j++)
				if (text_dir_files[j].d_type==4)
				{
					char *ctmp=(char *)calloc(1,256);
					strcpy(ctmp,text_dir_files[j].d_name);
					strcpy(text_dir_files[j].d_name,text_dir_files[i].d_name);
					strcpy(text_dir_files[i].d_name,ctmp);
					text_dir_files[i].d_type=4;
					text_dir_files[j].d_type=0;
					free(ctmp);
					break;
				}
	}

	return 0;
}


static inline void draw_loadMenu()
{
	int i,j;
	static int b=0;
	int bb=(b%6)/3;
	SDL_Rect r;
	extern SDL_Surface *text_screen;
	r.x=80-64; r.y=0; r.w=110+64+64; r.h=240;

	text_draw_background();
	text_draw_window(80-64,12,160+64+64,220,text_str_load_title);

	if (text_dir_num_files_index<min_in_dir)
	{
		min_in_dir=text_dir_num_files_index;
		max_in_dir=text_dir_num_files_index+SHOW_MAX_FILES;
	}
	else
		if (text_dir_num_files_index>=max_in_dir)
		{
			max_in_dir=text_dir_num_files_index+1;
			min_in_dir=max_in_dir-SHOW_MAX_FILES;
		}
	if (max_in_dir>text_dir_num_files)
		max_in_dir=text_dir_num_files-min_in_dir;


	for (i=min_in_dir,j=1;i<max_in_dir;i++,j+=2)
	{
		write_text(3,j,text_str_load_separator);

		SDL_SetClipRect(text_screen,&r);
		
		if ((text_dir_num_files_index==i)&&(bb))
			write_text_inv(4,j+1,text_dir_files[i].map);
		else
			write_text(4,j+1,(char *)text_dir_files[i].map);

		SDL_SetClipRect(text_screen,NULL);

		if (text_dir_files[i].d_type==4)
			write_text(32,j+1,text_str_load_dir);
	}
	write_text(3,j,text_str_load_separator);
	text_flip();
	b++;
}


static inline int key_loadMenu()
{
	int end=0;
	int left=0, right=0, up=0, down=0, hit0=0, hit1=0;
	SDL_Event event;

	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_QUIT)
			end=-1;
		else
		if (event.type == SDL_KEYDOWN)
		{
			switch(event.key.keysym.sym)
			{
				case SDLK_RIGHT: right=1; break;
				case SDLK_LEFT: left=1; break;
				case SDLK_UP: up=1; break;
				case SDLK_DOWN: down=1; break;
				case SDLK_LCTRL: hit0=1; break;
				case SDLK_LALT: hit1=1; break;
			}
			if (hit0)
			{
				if ((text_dir_files[text_dir_num_files_index].d_type==4)||(!strcmp(text_dir_files[text_dir_num_files_index].map,"."))||(!strcmp(text_dir_files[text_dir_num_files_index].map,"..")))
				{
					char *tmp=(char *)calloc(1,512);
					strcpy(tmp,text_dir_files[text_dir_num_files_index].map);
					if (getFiles(tmp))
						end=-1;
					free(tmp);
				}
				else
				{
					strcpy(dcastaway_image_file,text_dir_files[text_dir_num_files_index].map);
					changed_fdc0=1;
					end=1;
				}
			}
			else if (hit1)
				end=-1;
			else if ((up)&&(text_dir_num_files_index>0))
				text_dir_num_files_index--;
			else if ((down)&&(text_dir_num_files_index+1!=text_dir_num_files))
				text_dir_num_files_index++;
			else if (left)
			{
				text_dir_num_files_index-=SHOW_MAX_FILES;
				if (text_dir_num_files_index<0)
					text_dir_num_files_index=0;
			}
			else if (right)
			{
				text_dir_num_files_index+=SHOW_MAX_FILES;
				if (text_dir_num_files_index+1>=text_dir_num_files)
					text_dir_num_files_index=text_dir_num_files-1;
			}
		}
	}

	return end;
}

static inline void raise_loadMenu()
{
	int i;

	text_draw_background();
	text_flip();
	for(i=0;i<10;i++)
	{
		text_draw_background();
		text_draw_window(80-64,(10-i)*24,160+64+64,220,text_str_load_title);
		text_flip();
	}
}

static inline void unraise_loadMenu()
{
	int i;

	for(i=9;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(80-64,(10-i)*24,160+64+64,220,text_str_load_title);
		text_flip();
	}
	text_draw_background();
	text_flip();
}



int run_menuLoad()
{
	int end=0,c=0;

	if (text_dir_files==NULL)
	{
#ifdef DREAMCAST
		strcpy(actual_dir,MENU_DIR_DEFAULT);
#endif
		end=getFiles(MENU_DIR_DEFAULT);
	}

	text_dir_num_files_index=0;

	raise_loadMenu();
	while(!end)
	{
		draw_loadMenu(c);
		end=key_loadMenu(&c);
	}
	unraise_loadMenu();

	return end;
}
