#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include "menu.h"

extern int emulating;

#ifdef DREAMCAST
extern int __sdl_dc_wait_vblank;
#endif

static char *text_str_title="DCaSTaway - Main Menu --";
static char *text_str_load="Select Image Disk";
static char *text_str_throttle="Throttle ";
static char *text_str_0="0";
static char *text_str_50="50";
static char *text_str_100="100";
static char *text_str_150="150";
static char *text_str_200="200";
static char *text_str_frameskip="Frameskip";
static char *text_str_1="1";
static char *text_str_2="2";
static char *text_str_3="3";
static char *text_str_4="4";
static char *text_str_5="5";
static char *text_str_auto="auto";
static char *text_str_sound="Sound";
static char *text_str_on="on";
static char *text_str_off="off";
static char *text_str_vsync="VSync";
static char *text_str_separator="------------------------------";
static char *text_str_reset="Reset";
static char *text_str_run="Run";
static char *text_str_exit="Exit - Reboot Dreamcast";

int mainMenu_throttle=0;
int mainMenu_frameskip=-1;
int mainMenu_sound=1;
int mainMenu_speed=133;
int mainMenu_case=-1;
int mainMenu_vsync=0;

enum { MAIN_MENU_CASE_REBOOT, MAIN_MENU_CASE_LOAD, MAIN_MENU_CASE_RUN, MAIN_MENU_CASE_RESET, MAIN_MENU_CASE_CANCEL };

static inline void draw_mainMenu(int c)
{
	static int b=0;
	int bb=(b%6)/3;

	text_draw_background();
	text_draw_window(40,24,260,200,text_str_title);
	write_text(6,4,text_str_separator);
	if ((c==0)&&(bb))
		write_text_inv(6,5,text_str_load);
	else
		write_text(6,5,text_str_load);
	write_text(6,6,text_str_separator);
	
	write_text(6,8,text_str_throttle);
	if ((mainMenu_throttle==0)&&((c!=1)||(bb)))
		write_text_inv(17,8,text_str_0);
	else
		write_text(17,8,text_str_0);
	if ((mainMenu_throttle==50)&&((c!=1)||(bb)))
		write_text_inv(20,8,text_str_50);
	else
			write_text(20,8,text_str_50);
	if ((mainMenu_throttle==100)&&((c!=1)||(bb)))
		write_text_inv(23,8,text_str_100);
	else
		write_text(23,8,text_str_100);
	if ((mainMenu_throttle==150)&&((c!=1)||(bb)))
		write_text_inv(27,8,text_str_150);
	else
		write_text(27,8,text_str_150);
	if ((mainMenu_throttle==200)&&((c!=1)||(bb)))
		write_text_inv(31,8,text_str_200);
	else
		write_text(31,8,text_str_200);

	write_text(6,10,text_str_frameskip);
	if ((mainMenu_frameskip==0)&&((c!=2)||(bb)))
		write_text_inv(17,10,text_str_0);
	else
		write_text(17,10,text_str_0);
	if ((mainMenu_frameskip==1)&&((c!=2)||(bb)))
		write_text_inv(19,10,text_str_1);
	else
		write_text(19,10,text_str_1);
	if ((mainMenu_frameskip==2)&&((c!=2)||(bb)))
		write_text_inv(21,10,text_str_2);
	else
		write_text(21,10,text_str_2);
	if ((mainMenu_frameskip==3)&&((c!=2)||(bb)))
		write_text_inv(23,10,text_str_3);
	else
		write_text(23,10,text_str_3);
	if ((mainMenu_frameskip==4)&&((c!=2)||(bb)))
		write_text_inv(25,10,text_str_4);
	else
		write_text(25,10,text_str_4);
	if ((mainMenu_frameskip==5)&&((c!=2)||(bb)))
		write_text_inv(27,10,text_str_5);
	else
		write_text(27,10,text_str_5);
	if ((mainMenu_frameskip==-1)&&((c!=2)||(bb)))
		write_text_inv(29,10,text_str_auto);
	else
		write_text(29,10,text_str_auto);

	write_text(6,12,text_str_sound);
	if ((mainMenu_sound==0)&&((c!=3)||(bb)))
		write_text_inv(13,12,text_str_off);
	else
		write_text(13,12,text_str_off);
	if ((mainMenu_sound!=0)&&((c!=3)||(bb)))
		write_text_inv(18,12,text_str_on);
	else
		write_text(18,12,text_str_on);

	write_text(6,14,text_str_vsync);
	if ((mainMenu_vsync==0)&&((c!=4)||(bb)))
		write_text_inv(13,14,text_str_off);
	else
		write_text(13,14,text_str_off);
	if ((mainMenu_vsync!=0)&&((c!=4)||(bb)))
		write_text_inv(18,14,text_str_on);
	else
		write_text(18,14,text_str_on);
	
	write_text(6,16,text_str_separator);
	if ((c==5)&&(bb))
		write_text_inv(6,17,text_str_reset);
	else
		write_text(6,17,text_str_reset);
	write_text(6,18,text_str_separator);

	write_text(6,20,text_str_separator);
	if ((c==6)&&(bb))
		write_text_inv(6,21,text_str_run);
	else
		write_text(6,21,text_str_run);
	write_text(6,22,text_str_separator);

	write_text(6,24,text_str_separator);
	if ((c==7)&&(bb))
		write_text_inv(6,25,text_str_exit);
	else
		write_text(6,25,text_str_exit);
	write_text(6,26,text_str_separator);

	text_flip();
	b++;
}

static inline int key_mainMenu(int *cp)
{
	int c=(*cp);
	int end=0;
	int left=0, right=0, up=0, down=0, hit0=0, hit1=0;
	SDL_Event event;

	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_QUIT)
		{
			mainMenu_case=MAIN_MENU_CASE_REBOOT;
			end=-1;
		}
		else
		if (event.type == SDL_KEYDOWN)
		{
			switch(event.key.keysym.sym)
			{
				case SDLK_RIGHT: right=1; break;
				case SDLK_LEFT: left=1; break;
				case SDLK_UP: up=1; break;
				case SDLK_DOWN: down=1; break;
				case SDLK_LCTRL: hit0=1; break;
				case SDLK_LALT: hit1=1; break;
			}
			if (hit1)
			{
				mainMenu_case=MAIN_MENU_CASE_CANCEL;
				end=1;
			}
			else if (up)
			{
				if (c>0) c=(c-1)%8;
				else c=7;
			}
			else if (down)
				c=(c+1)%8;
			else
			switch(c)
			{
				case 0:
					if (hit0)
					{
						mainMenu_case=MAIN_MENU_CASE_LOAD;
						end=1;
					}
					break;
				case 1:
					if (left)
					{
						if (mainMenu_throttle>0)
							mainMenu_throttle-=50;
						else
							mainMenu_throttle=200;
					}
					else if (right)
					{
						if (mainMenu_throttle<200)
							mainMenu_throttle+=50;
						else
							mainMenu_throttle=0;
					}
					break;
				case 2:
					if (left)
					{
						if (mainMenu_frameskip>-1)
							mainMenu_frameskip--;
						else
							mainMenu_frameskip=5;
					}
					else if (right)
					{
						if (mainMenu_frameskip<5)
							mainMenu_frameskip++;
						else
							mainMenu_frameskip=-1;
					}
					break;
				case 3:
					if (left)
					{
						if (mainMenu_sound)
							mainMenu_sound=0;
					}
					else if (right)
					{
						if (!mainMenu_sound)
							mainMenu_sound=1;
					}
					break;
				case 4:
					if (left)
					{
						if (mainMenu_vsync)
							mainMenu_vsync=0;
					}
					else if (right)
					{
						if (!mainMenu_vsync)
							mainMenu_vsync=1;
					}
					break;
				case 5:
					if (hit0)
					{
						mainMenu_case=MAIN_MENU_CASE_RESET;
						end=1;
					}
					break;
				case 6:
					if (hit0)
					{
						mainMenu_case=MAIN_MENU_CASE_RUN;
						end=1;
					}
					break;
				case 7:
					if (hit0)
					{
						mainMenu_case=MAIN_MENU_CASE_REBOOT;
						end=1;
					}
					break;
			}
		}
	}


	(*cp)=c;
	return end;
}

static inline void raise_mainMenu()
{
	int i;

	text_draw_background();
	text_flip();
	for(i=0;i<10;i++)
	{
		text_draw_background();
		text_draw_window(40,(10-i)*24,260,200,text_str_title);
		text_flip();
	}
}

static inline void unraise_mainMenu()
{
	int i;

	for(i=9;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(40,(10-i)*24,260,200,text_str_title);
		text_flip();
	}
	text_draw_background();
	text_flip();
}

static inline void drawNoRun(void)
{
	int i;
	
	for(i=0;i<20;i++)
	{
		text_draw_background();
		text_draw_window(64,120,160,32,"--- ERROR ---");
		write_text(9,16,"Game not running");
		text_flip();
	}
}

void drawNoRom(void)
{
	int i;
	SDL_Event ev;

	for(i=0;i<20;i++)
	{
		text_draw_background();
		text_draw_window(54,110,250,64,"--- ERROR ---");
		write_text(14,14,"ROM not found");
		write_text(8,16,"Press any button to retry");
		text_flip();
	}
	SDL_Delay(333);
    	while(SDL_PollEvent(&ev))
		if (ev.type==SDL_QUIT)
			exit(1);
		else
		    SDL_Delay(10);
    	while(!SDL_PollEvent(&ev))
		    SDL_Delay(10);
    	while(SDL_PollEvent(&ev))
		if (ev.type==SDL_QUIT)
			exit(1);
	text_draw_background();
	text_flip();
	SDL_Delay(333);
}

int run_mainMenu()
{
	int end,c=0;
	mainMenu_case=-1;
#ifdef DREAMCAST
	__sdl_dc_wait_vblank=0;
#endif
	while(mainMenu_case<0)
	{
		raise_mainMenu();
		end=0;
		while(!end)
		{
			draw_mainMenu(c);
			end=key_mainMenu(&c);
		}
		unraise_mainMenu();
		switch(mainMenu_case)
		{
			case MAIN_MENU_CASE_LOAD:
				run_menuLoad();	
				mainMenu_case=-1;
				break;
			case MAIN_MENU_CASE_RUN:
				mainMenu_case=1;
				break;
			case MAIN_MENU_CASE_RESET:
				if (emulating)
					mainMenu_case=2;
				else
				{
					drawNoRun();
					mainMenu_case=-1;
				}
				break;
			case MAIN_MENU_CASE_REBOOT:
				SDL_Quit();
#ifdef DREAMCAST
				arch_reboot();
#else
				exit(0);
#endif
				break;
			default:
				mainMenu_case=-1;
		}
	}

	text_draw_window(96,64,140,32,"-------");
	write_text(14,9,"Please wait");
	text_flip();

#ifdef DREAMCAST
	__sdl_dc_wait_vblank=mainMenu_vsync;
#endif
	return mainMenu_case;
}
